﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraActivityIndicator1.Text = "Stopped";
            ultraActivityIndicator1.AnimationEnabledText = "Please wait while processing...";
            ultraActivityIndicator1.AnimationSpeed = 20;
            ultraActivityIndicator1.AnimationEnabled = true;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Action computeServicesWork = ComputeServices;
            Task.Run(computeServicesWork);
        }

        private void ComputeServices()
        {
            // Thread.Sleep simulates work for 5 seconds
            Thread.Sleep(5000);

            DataTable dataTableGrid = new DataTable();
            dataTableGrid.Columns.Add("id", typeof(int)).AutoIncrement = true;
            for (int i = 0; i < 5; i++)
            {
                dataTableGrid.Columns.Add(string.Format("Col{0}", i), typeof(string)).DefaultValue = "Some text";
            }
            for (int i = 0; i < 100; i++)
            {
                dataTableGrid.Rows.Add();
            }

            // Work done
            // Making thread-safe calls to Windows Forms Controls
            StopActivityIndicator();
            SetActivityIndicatorHidden();
            SetGridDataTable(dataTableGrid);
        }

        private void StopActivityIndicator()
        {
            if (this.ultraActivityIndicator1.InvokeRequired)
            {
                Action doMethod = StopActivityIndicator;
                this.Invoke(doMethod);
            }
            else
            {
                this.ultraActivityIndicator1.Stop();
            }
        }

        private void SetActivityIndicatorHidden()
        {
            if (this.ultraActivityIndicator1.InvokeRequired)
            {
                Action doMethod = SetActivityIndicatorHidden;
                this.Invoke(doMethod);
            }
            else
            {
                this.ultraActivityIndicator1.Visible = false;
            }
        }

        private void SetGridDataTable(DataTable table)
        {
            if (this.ultraGrid1.InvokeRequired)
            {
                Action<DataTable> doMethod = SetGridDataTable;
                this.Invoke(doMethod, new object[] { table });
            }
            else
            {
                this.ultraGrid1.DataSource = table;
            }
        }
    }
}
